Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## jason.stdlib
Class findall

    java.lang.Object
      jason.asSemantics.DefaultInternalAction
          jason.stdlib.findall

All Implemented Interfaces:
  InternalAction, java.io.Serializable

    public class findall

extends DefaultInternalAction

Internal action: `.findall(Var,Literal,List)`.

Description: builds a List of all instantiations of term which make query a logical consequence of the agent's BB. Unlike in Prolog, the second argument cannot be a conjunction.

Parameters:

- + term (variable or structure): the variable or structure whose instances will "populate" the list.
- + query (logical formula): the formula used to find literals in the belief base; is has the same syntax as the plan context.
- +/- result (list): the result list populated with found solutions for the query.

Examples assuming the BB is currently {a(30),a(20),b(1,2),b(3,4),b(5,6)}:

- `.findall(X,a(X),L)`: `L` unifies with `[30,20]`.
- `.findall(c(Y,X),b(X,Y),L)`: `L` unifies with `[c(2,1),c(4,3),c(6,5)]`.
- `.findall(r(X,V1,V2), (a(X) & b(V1,V2) & V1*V2 < X), L)`: `L` unifies with `[r(30,1,2),r(30,3,4),r(20,1,2),r(20,3,4)]`.

See Also:
  `count`, Serialized Form

Constructor Summary
`findall()`

Method Summary
`protected void` | `checkArguments(Term[] args)`
`java.lang.Object` | `execute(TransitionSystem ts, Unifier un, Term[] args)` Executes the internal action.
`int` | `getMaxArgs()`
`int` | `getMinArgs()`
`Term[]` | `prepareArguments(Literal body, Unifier un)` Prepare body's terms to be used in 'execute', normally it consist of cloning and applying each term

Methods inherited from class jason.asSemantics.DefaultInternalAction
`canBeUsedInContext, suspendIntention`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### findall

    public findall()

Method Detail

### getMinArgs

    public int getMinArgs()

  Overrides:
    `getMinArgs` in class `DefaultInternalAction`

### getMaxArgs

    public int getMaxArgs()

  Overrides:
    `getMaxArgs` in class `DefaultInternalAction`

### prepareArguments

    public Term[] prepareArguments(Literal body,
                                   Unifier un)

  Description copied from interface: `InternalAction`
  Prepare body's terms to be used in 'execute', normally it consist of cloning and applying each term

  Specified by:
    `prepareArguments` in interface `InternalAction`
  Overrides:
    `prepareArguments` in class `DefaultInternalAction`

### checkArguments

    protected void checkArguments(Term[] args)
                           throws JasonException

  Overrides:
    `checkArguments` in class `DefaultInternalAction`
  Throws:
    `JasonException`

### execute

    public java.lang.Object execute(TransitionSystem ts,
                                    Unifier un,
                                    Term[] args)
                             throws java.lang.Exception

  Description copied from interface: `InternalAction`
  Executes the internal action. It should return a Boolean or an Iterator. A true boolean return means that the IA was successfully executed. An Iterator result means that there is more than one answer for this IA (e.g. see member internal action).

  Specified by:
    `execute` in interface `InternalAction`
  Overrides:
    `execute` in class `DefaultInternalAction`
  Throws:
    `java.lang.Exception`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD